#include "Expression.h"
#include <stdlib.h>

// calculate the code using the arguments and also the 'code'
DSCP * vect( std::vector<DSCP *> & tmp, int i);

char* Expression::calculateCode(Tree* t)
{
	DSCP* dscp = cg->findDSCP( t->data.c_str() );
	if ( (dscp == 0) && (t->type != 'F') ) throw Except ( "Unknown Identifier");
	
	// bad style programming
	char* res  = new char [100];
	switch(t->type)
	{
	case('I'):
		return  (char*)dscp->getcode().c_str() ;
	case('A'):
		if (t->arguments->size() == 1)
		{
			Expression* e = new Expression( t->arguments->at(0), cg);
			strcpy(res,"");
			
			char * code = new char[100];
			strcpy( code, dscp->getcode().c_str());
			
			// Something ugly!
			// If the array type is pointer, first of all
			// we should move the value of it to bx.after
			// that we use it for indirect addressing
			// --> a[1] if a is int* is different from int[]  !!

			if ( dscp->getmytype() == CHARSTAR || dscp->getmytype() == INTSTAR)
			{
				sprintf(translate,"%s%s%s%s",
				translate,
				"\tmov  bx , ",
				code,
				"\n"
				);
				
				// same as below 
				
				strcpy( code , "[bx" );
			}
				



			// if the last char of the code is "]" then eliminate it
			// The coder for array attaches a "+si" string to the dscp's code
			if ( code[strlen(code) - 1] == ']' )
				code[strlen(code) - 1] = '\0';
			
			
			if ( code[0] == '[' )
				sprintf(res,"%s%s",
					code,
					" + si]"
					);
			else 
				sprintf(res,"%s%s%s",
					"[",
					code,
					" + si]"
					);


			delete code;
			sprintf(translate,"%s%s%s%s",
				translate,
				e->getExpression().c_str(),
				"\tpop  si\n",
				"\tshl  si , 1\n"
				);
			return res;
		}
		else
		{
			Expression* e1 = new Expression( t->arguments->at(0), cg);
			Expression* e2 = new Expression( t->arguments->at(1), cg);
			strcpy(res,"");
			
			// Doing as the one-dimensional array

			char * code = new char[100];
			strcpy( code, dscp->getcode().c_str());
			
			if ( code[strlen(code) - 1] == ']' )
				code[strlen(code) - 1] = '\0';
			sprintf(res,"%s%s",
				code,
				" + si]"
				);
			char* size = new char[10];
			itoa( static_cast<TwoDArr*>(dscp)->getsize(),size,10);
			sprintf(translate,"%s%s%s%s%s%s%s%s%s%s%s",
				translate,
				e1->getExpression().c_str(),
				e2->getExpression().c_str(),
				"\tpop  si\n",
				"\tpop  di\n",
				"\tpush ax\n",
				"\tmov  ax , ",
				size,
				"\n\tmul  di\n",
				"\tadd  si , ax\n",
				"\tpop  ax\n"
				);
			return res;
		}
	case('F'):
		Expression* e;
		//for( int i = 0; i < t->arguments->size(); i++)
		for( int i = t->arguments->size() - 1 ; i >= 0; i--)
		{
			 e = new
				 Expression( t->arguments->at(i), cg);
			 sprintf(translate,"%s%s",
				translate,
				e->getExpression().c_str()
				);
			 delete e;
		}
		//strcpy(res,"");
		STRING temp = int2String( 2 * t->arguments->size() );
		sprintf(translate,"%s%s%s%s%s%s%s",
			translate,
			"\tcall  near ptr __",
			t->data.c_str(),
			"\n",
			//"\tpush ax\n",
			"\tadd  sp , ",
			temp.c_str(),
			"\n"
			);

		return "ax";
		
	}

	throw Except("ASSERT");
	return "";
}


bool Expression::eliminateConstantCherry(Tree* t)
{
	if ( (t->left) && (t->right) )
	{
		if ( (t->left->type == 'C') && (t->right->type == 'C') )
		{
			int first  = atoi(t->left->data.c_str()); 
			int second = atoi(t->right->data.c_str()); 
			int result = 0;
			switch(t->data[0])
			{
			case('+'):
				result = first + second ;
				break;
			case('-'):
				result = first - second ;
				break;
			case('*'):
				result = first * second ;
				break;
			case('/'):
				if ( second == '0') throw Except("Division by zero");
				result = first / second ;
				break;
			}
			t->data = int2String( result);
			t->type = 'C';
			delete t->left;
			delete t->right;
			t->left  = NULL;
			t->right = NULL;

			return true;
		}
	}
	return false;
}

void Expression::checkConstant(Tree* t)
{
	if (t->type == 'C')
	{
		sprintf(translate,"%s%s%s",
			"\tpush ",
			(t->data).c_str(),
			"\n"
			);
	}
	else if (t->type == 'F')
		sprintf( translate, "%s%s%s%s",
			translate,
			"\tpush ",
			calculateCode( t),
			"\n"
			);
	// if there is an operator after the id, the code has already calculated
	
	else if ( ( (t->type == 'I') && (!isUnaryAfter(t)) ) || t->type == 'A')
	{
		sprintf( translate, "%s%s%s%s",
			translate,
			"\tpush ",
			calculateCode( t),
			"\n"
			);
	}
}

void Expression::comparative(char *what)
{
	STRING L1 = cg->nextLabel();
	STRING L2 = cg->nextLabel();

	sprintf(translate,"%s%s%s%s%s%s",
				translate,
				"\tcmp  ax , dx\n" ,
				what,  
				"  short ",
				L1.c_str(),
				"\n");
	sprintf(translate,"%s%s%s%s%s%s%s",
				translate,
				"\tmov  ax , 1\n",
				"\tjmp  short ",
				L2.c_str(),
				"\n",
				L1.c_str(),
				":\n");
	sprintf(translate,"%s%s%s%s%s",
				translate,
				"\txor  ax , ax\n",
				L2.c_str(),
				":\n",
				"\tpush ax\n");

}


bool Expression::isUnaryAfter( Tree* t)
{
	if ( t->right)
	{
		if ( (t->right->data == "++") || (t->right->data == "--") )
			return true;
	}
	return false;
}



void Expression::checkUnaryAfter( Tree* t)
{
	if ( t->right)
	{
		if ( (t->right->data == "++"))
		{
			char * mycode = calculateCode(t); 
			sprintf(translate,"%s%s%s%s%s%s",translate,"\tinc ", mycode, "\n\tpush ",
				mycode,"\n");
		}
		else if ( (t->right->data == "--"))
		{
			char * mycode = calculateCode(t); 
			sprintf(translate,"%s%s%s%s%s%s",translate,"\tdec ", mycode, "\n\tpush ",
				mycode,"\n");
		}
	}
}

//----------------------------------------------------------------------------------------------

void Expression::putPop( int a)
{
	char* cur = translate + strlen(translate) - INSTLEN;
	if (a == 1)
	{
		if ( !strcmp(cur,"\tpush dx\n") ) 
		{
			translate[strlen(translate) - INSTLEN] = '\0';
			return;
		}
		sprintf(translate,"%s%s",translate,"\tpop  dx\n");
	} 
	else
	{
		if ( !strcmp(cur,"\tpush ax\n") ) 
		{
			translate[strlen(translate) - INSTLEN] = '\0';
			return;
		}
		sprintf(translate,"%s%s",translate,"\tpop ax\n");
	}
}


// getting the descriptor from the leaf
// we cannot use the STACK method for side-effect operators

Tree* Expression::getDSCP( Tree* t)
{
	while( t->type == 'O' )
		t = t->right;
	return t;
}


// Making the left and right operands available

void Expression::makeAvail( Tree* t)
{
	// If the operator is .... we should change our algorithm
	// The availabitlity of operands is by DSCP not stack!
	
	bool ispp = 
		(!strcmp(t->data.c_str(),"++")) || (!strcmp(t->data.c_str(),"--")) ;

	if ( (t->data[0] == '&') && (!t->left) )
		return;
	
	if ( t->right)
	{
		switch(t->right->type)
		{
			case('C'):
				sprintf(translate,"%s%s%s%s",translate,"\tmov  dx , ", t->right->data.c_str(),"\n");
				break;
			case('O'):
				putPop(1);
				break;
			case('I'):
			case('A'):
			case('F'):
				if (ispp) break;
				//dscp = cg->findDSCP( t->right->data);
				char * mycode = calculateCode(t->right); 
				sprintf(translate,"%s%s%s%s",translate,"\tmov  dx , ", mycode,"\n");
				//checkUnaryAfter(t->right);

				// if the left tree has arguments we have to push dx and after
				// calculating the right tree we pop it !!!

				if ( t->left->arguments )
				{
					sprintf(translate,"%s%s", translate,
						"\tpush dx\n");
					putPushDxForArguments = true;
				}

				break;
		}
	}
	if ( t->left)
	{
		switch(t->left->type)
		{
			case('C'):
			{
				sprintf(translate,"%s%s%s%s",translate,"\tmov  ax , ", t->left->data.c_str() ,"\n");
				break;
			}
			case('O'):
				putPop(0);
				break;
			case('I'):
			case('A'):
			case('F'):
				if (ispp) break;
				//dscp = cg->findDSCP( t->left->data);
				// if the operator is = ,  we dont need to make
				// the left available via ax, because we grab its DSCP
				if (t->data != "=")
				{
					char * mycode = calculateCode(t->left); 
					if ( strcmp( mycode, "ax") )
						sprintf(translate,"%s%s%s%s",translate,"\tmov  ax , ", mycode,"\n");
				}
				if (putPushDxForArguments)
				{
					sprintf(translate,"%s%s",
						translate, "\tpop  dx\n");
					putPushDxForArguments = false;
				}

				//checkUnaryAfter(t->left);
				break;
		}
	}
}

bool Expression::isLeaf(Tree* t)
{
	checkUnaryAfter(t);
	if ( (t->type == 'C') || (t->type == 'I') /*|| (t->type == 'F')*/  ) return true;
	return false;
}

void Expression::AssignCodeBX(Tree* t)
{
	// The code for assignment
	char * mycode = calculateCode(getDSCP(t->left)); 
	sprintf(translate,"%s%s%s%s%s",
		translate,
		"\tmov  ",
		mycode,
		" , dx\n",
		"\tpush dx\n");
}

void Expression::AssignCodeAX(Tree* t)
{
	// The code for assignment
	char * mycode = calculateCode(getDSCP(t->left)); 
	sprintf(translate,"%s%s%s%s%s",
		translate,
		"\tmov  ",
		mycode,
		" , ax\n",
		"\tpush ax\n");
}

void Expression::AddCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\tadd  ax , dx\n");
}

void Expression::SubCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\tsub  ax , dx\n");
}

void Expression::MulCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\timul dx\n");
}

void Expression::DivCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\timul dx\n" );
}

void Expression::AndCode(Tree* t) 
{
	sprintf( translate,"%s%s", translate, "\tand ax , dx\n");
}

void Expression::OrCode(Tree* t)
{
	sprintf(translate,"%s%s",	translate, "\tor   ax , dx\n");
}

void Expression::ShlCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\tshl  ax , bl\n");
}

void Expression::ShrCode(Tree* t)
{
	sprintf(translate,"%s%s",translate,"\tshr  ax , bl\n");
}

void Expression::PushCode(Tree* t)
{
	sprintf(translate,"%s%s",translate, "\tpush ax\n");
}

void Expression::TCG(Tree* t)
{
	// Is NULL ??---------------------------------------
	if ( !t ) return;

	// Is leaf ??---------------------------------------
	if ( isLeaf(t) ) return;
    
	// -------------------------------------------------
	TCG(t->left);
	TCG(t->right);
	if (t->type == 'O')
	{
		eliminateConstantCherry(t);
		makeAvail(t);
		// Labeling the assembly code

		//	STRING L1 = cg->nextLabel();
		//	STRING L2 = cg->nextLabel();
	//		STRING L3 = cg->nextLabel();
		switch(t->data[0])
		{
		case('+'):
			if ( t->data[1] == '+')
			{
				char * mycode = calculateCode( getDSCP(t) ); 
				sprintf(translate,"%s%s%s%s%s%s",translate,"\tinc  ",
					mycode,
					"\n\tpush ",mycode,"\n");
				break; 
			}
			else if ( t->data[1] == '=')
			{
				AddCode(t);
				AssignCodeAX(t);
				break; 
			}
			if (( t->left == NULL) )
			{
				sprintf(translate,"%s%s",translate,"\tpush dx\n");
				break;
			}
			AddCode(t);
			PushCode(t);
			break;
		case('-'):
			if ( t->data[1] == '-') 
			{
				char * mycode = calculateCode( getDSCP(t) ); 
				sprintf(translate,"%s%s%s%s%s%s",translate,"\tdec  ",
					mycode,
					"\n\tpush ",mycode,"\n");
				break;
			}
			else if ( t->data[1] == '=')
			{
				SubCode(t);
				AssignCodeAX(t);
				break; 
			}
			if ( t->left == NULL)
			{
				sprintf(translate,"%s%s%s",translate,"\tneg  dx\n", "\tpush dx\n");
				break;
			}
			SubCode(t);
			PushCode(t);
			break;
		case('*'):
			if ( t->data[1] == '=')
			{
				MulCode(t);
				AssignCodeAX(t);
				break; 
			}
			if ( t->left == NULL)
			{
				sprintf(translate,"%s%s%s",translate,"\tmov  cx , [dx]\n", "\tpush cx\n");
				break;
			}
			MulCode(t);
			PushCode(t);
			break;
		case('/'):
			if ( t->data[1] == '=')
			{
				DivCode(t);
				AssignCodeAX(t);
				break; 
			}
			DivCode(t);
			PushCode(t);
			break;
		case('<'):
			if ( t->data[1] == '<') 
			{
				ShlCode(t);
				PushCode(t);
				break;
			}
			else if( t->data[2] == '=')
			{
				ShlCode(t);
				AssignCodeAX(t);
				break; 
			}
			comparative("\tjae");
			break;
		case('>'):
			if ( t->data[1] == '>') 
			{
				ShrCode(t);
				PushCode(t);
				break;
			}
			else if( t->data[2] == '=')
			{
				ShrCode(t);
				AssignCodeAX(t);
				break; 
			}
			comparative("\tjbe");
			break;
		case('!'):
			if ( t->data[1] == '=') 
			{	
				comparative("\tje");
				break;
			}
			sprintf(translate,"%s%s%s%s%s",translate,
				"\tneg  dx\n","\tsbb  dx,dx\n","\tsbb  dx,dx\n","\tpush dx\n");
			break;
		case('&'):
		{
			//DSCP* dscp = findDSCP( t->right->data);
			STRING L1 = cg->nextLabel();
			STRING L2 = cg->nextLabel();
			STRING L3 = cg->nextLabel();
			// The code for &&

			if ( t->data[1] == '&')
			{
				sprintf(translate,"%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
				translate,
				"\tcmp  ax , 0\n" ,
				"\tje" ,    
				"   short ",
				L1.c_str(),
				"\n",
				"\tcmp  dx , 0\n",
				"\tje   short ",
				L2.c_str(),
				"\n",
				"\tmov  ax , 1\n",
				"\tjmp  short ",
				L2.c_str(),
				"\n",
				L1.c_str(),
				":\n",
				"\txor  ax , ax\n",
				L2.c_str(),
				":\n",
				"\tpush ax\n");
				break;
			}
			// The code for &x - address of operator
			if (!t->left)
			{
				char * mycode = calculateCode( getDSCP(t) ); 
				sprintf(translate,"%s%s%s%s%s",
				translate,"\tlea dx , ", mycode, "\n",
				"\tpush dx\n");
				break;
			}
			
			// The code for a & b - AND operator
			if( t->data[1] == '=')
			{
				AndCode(t);
				AssignCodeAX(t);
				break; 
			}
			AndCode(t);
			PushCode(t);
			break;
		}
		case('='):
			if ( t->data[1] == '=') 
			{
				comparative("\tjne");
				break;
			}
			AssignCodeBX(t);
			break;
		case('|'):
		{
			STRING L1 = cg->nextLabel();
			STRING L2 = cg->nextLabel();
			STRING L3 = cg->nextLabel();
			if ( t->data[1] == '|') 
			{
				sprintf(translate,"%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
				translate,
				"\tcmp  ax , 0\n" ,
				"\tjne" ,    
				"   short ",
				L1.c_str(),
				"\n",
				"\tcmp  dx , 0\n",
				"\tje   short ",
				L2.c_str(),
				"\n",
				L1.c_str(),
				":\n",
				"\tmov  ax , 1\n",
				"\tjmp  short ",
				L3.c_str(),
				"\n",
				L2.c_str(),
				":\n",
				"\txor  ax , ax\n",
				L3.c_str(),
				":\n",
				"\tpush ax\n");
				break;
			}
			else if( t->data[1] == '=')
			{
				OrCode(t);
				AssignCodeAX(t);
				break; 
			}
			OrCode(t);
			PushCode(t);
			break;
		}  //case//
	}
	}
}

Expression::Expression( Tree* t, CCodeGenerator* cg)
{
	putPushDxForArguments = false;
	translate =new char [100000];
	strcpy( translate, "");
	this->cg = cg;
	TCG( t);
	checkConstant(t);
}

STRING Expression::getExpression()
{
	STRING temp( translate);
	return temp;
}
